//	Part of Project: AD Product Configurator
//	(c): Ador Design (S. Bzdak / F. Bzdak) (all rights reserved).

"use strict";

// possible options to run selecty
var AD_PC_VERSION_STANDALONE = 'ad_pc_version_standalone';
var AD_PC_VERSION_XTC = 'ad_pc_version_xtc';

// -------------------------------------------------
// Configuration block for different versions to run
// set '_ad_pc_version_running' to one of the defined values at the top of this script

var _ad_pc_version_running = AD_PC_VERSION_XTC;
// var _ad_pc_version_running = AD_PC_VERSION_STANDALONE;
// -------------------------------------------------

// setup for standalone
var configurator_path = '../../server/frontend/configurator.php';
var sessionHandlerPath = '../../server/frontend/sessionHandler.php';
var picturePath = '../../img/source/';
var translationBasePath = "../../server/conf/lang/";

// setup for XTC
if( _ad_pc_version_running == AD_PC_VERSION_XTC ) {
	configurator_path = 'plugins/ad_selecty/src/server/frontend/configurator.php';
	sessionHandlerPath = 'plugins/ad_selecty/src/server/frontend/sessionHandler.php';
	picturePath = 'plugins/ad_selecty/src/img/source/';
	translationBasePath = "plugins/ad_selecty/src/server/conf/lang/";
}

var contentDiv = '#ad_pc_config_content'; //Div für den Inhalt der Konfiguration
var infoDiv = '#ad_pc_config_content_info'; //Div für Anzeige der aktuellen Konfiguration
var priceTitle = '';			// notice: set to value different from '' to activate pre label before positive price (i.e. 'zzgl.')
var priceNegativeTitle = '';	// notice: set to value different from '' to activate pre label before negative price (i.e. 'abzgl.')


// ****************************
// Ab hier nichts mehr ändern.
// ****************************

var _configStarted = false;
var configFinished = false;
var configLevel = 1;
var id = 1;
var _productId;
var _configDivId;
var prices = {};
var configuration = {};
var infoContentEntryArray = [];
var lock = false;
var _tranlationsLoaded = false;
var _baseValuesInitialized = false;

var _discountMultiplier = 1;
var _currencyString = 'EUR';		// XTC overrides the default in method 'setXtcBaseValues( basePrice, currency, priceTotalString, pricesIncludeTax, taxValue, taxInfoString, shippingInfoString, shippingLink, licOption )'
var _xtcPriceTotalString = '';		// XTC sets the default in method 'setXtcBaseValues( basePrice, currency, priceTotalString, pricesIncludeTax, taxValue, taxInfoString, shippingInfoString, shippingLink, licOption )'
var _taxInfoString = '';			// XTC sets the default in method 'setXtcBaseValues( basePrice, currency, priceTotalString, pricesIncludeTax, taxValue, taxInfoString, shippingInfoString, shippingLink, licOption )'
var _shippingInfoString = '';		// XTC sets the default in method 'setXtcBaseValues( basePrice, currency, priceTotalString, pricesIncludeTax, taxValue, taxInfoString, shippingInfoString, shippingLink, licOption )'
var _pricesIncludeTax = 1;			// XTC sets the default in method 'setXtcBaseValues( basePrice, currency, priceTotalString, pricesIncludeTax, taxValue, taxInfoString, shippingInfoString, shippingLink, licOption )'
var _taxValue = 0;					// XTC sets the default in method 'setXtcBaseValues( basePrice, currency, priceTotalString, pricesIncludeTax, taxValue, taxInfoString, shippingInfoString, shippingLink, licOption )'
var _config_big_picture_top_min_dist = 15;
var _adPcUserInputExisting = false;
var _licOption = "0001000";			// Option "0001000" -> User Input

// XTC specific
var _xtcBasePrice = 0;
var _xtcShippingLink = false;

// CSV-price change var
var _csvPriceChgC = {
	prc_chg: null,
    setInfoContent: false,
	useCsvPriceOnly: false,
	setInfoContent_name: null,
    setInfoContent_value: null
};

function resetCsvPriceChgC() {
    _csvPriceChgC.prc_chg = null;
    _csvPriceChgC.setInfoContent = false;
    _csvPriceChgC.useCsvPriceOnly = false;
    _csvPriceChgC.setInfoContent_name = null;
    _csvPriceChgC.setInfoContent_value = null;
}

function checkResponse(response, adOptions) {
	if (lock === false) {
		lock = true;
		var configStartSuccess = true;
		if (response) {
			if (response.ad_error) {
				configStartSuccess = false;
				if( _ad_pc_version_running == AD_PC_VERSION_XTC ) {
					var submitButtons = getXtcAddToCartButtons();
					$ad_pc_jq_1_11_3.each(submitButtons, function( index, value ) {
						value.prop('disabled', false);
                        if( _adPcUserInputExisting && !checkOptionBitwise( _licOption, '0001000' ) ) {		// option:  0001000	=> user input
							value.prop('disabled', true);
						}
					});
				}
				else {
					if (response.ad_error !== '') {
						console.log(response.ad_error);
					}
				}
			} else if (response.is_leaf !== true && configFinished === false) {
				if( _ad_pc_version_running == AD_PC_VERSION_XTC ) {
					var submitButtons = getXtcAddToCartButtons();
					$ad_pc_jq_1_11_3.each(submitButtons, function( index, value ) {
						value.prop('disabled', true);
					});
				}

				// create config and content area
				$ad_pc_jq_1_11_3(contentDiv).append('<div class="product_config" id="product_config_lvl_' + configLevel + '">');
				$ad_pc_jq_1_11_3("#product_config_lvl_" + configLevel).append('<label class="title">' + response.title + '</label>');
				if (response.descr) {
					$ad_pc_jq_1_11_3("#product_config_lvl_" + configLevel).append('<label class="description">' + response.descr + '</label>');
				}
				$ad_pc_jq_1_11_3("#product_config_lvl_" + configLevel).append('<div class="optionValueSeperator"></div>');

				var i = 0;
				response.values.sort(function (a, b) {
					if (a.val_pos == b.val_pos) {
						return 0;
					}
					return parseInt(a.val_pos) < parseInt(b.val_pos) ? -1 : 1;
				});
				for (i = 0; i < response.values.length; i++) {
					if( response.values[i].usr_inp_col != '' ) {
						_adPcUserInputExisting = true;
					}

					// setup data values for assignment keys and assigned keys
                    var dataValues = '';
					var assignment_key_prc_factor_class = '';
                    var assignment_key_prc_percent_class = '';
					if( response.values[i].assignment_key_prc_factor && response.values[i].assignment_key_prc_factor != '' ) {
                        dataValues += ' data-ad_pc_assignment_key_prc_fact="' + response.values[i].assignment_key_prc_factor + '"';
                        assignment_key_prc_factor_class = ' ad_pc_assignment_key_prc_factor_existing';
					}
					if( response.values[i].assignment_key_prc_percent && response.values[i].assignment_key_prc_percent != '' ) {
						dataValues += ' data-ad_pc_assignment_key_prc_perc="' + response.values[i].assignment_key_prc_percent + '"';
                        assignment_key_prc_percent_class = ' ad_pc_assignment_key_prc_percent_existing';
					}
                    if ( response.values[i].price_factor_assigned_key && response.values[i].price_factor_assigned_key != '' ) {
                        dataValues += ' data-ad_pc_prc_fact_assigned_key="' + response.values[i].price_factor_assigned_key + '"';
                    }
                    if ( response.values[i].price_factor_type && response.values[i].price_factor_type != '' && response.values[i].price_factor_type != 0 ) {
                        dataValues += ' data-ad_pc_prc_fact_type="' + response.values[i].price_factor_type + '"';
                    }
                    if ( response.values[i].price_percent_assigned_key && response.values[i].price_percent_assigned_key != '' ) {
                        dataValues += ' data-ad_pc_prc_perc_assigned_key="' + response.values[i].price_percent_assigned_key + '"';
                    }

                    // Handle tax.
					response.values[i].price_chg = handleTax( response.values[i].price_chg );

					// setup picture options
					if (response.values[i].img_path != '') {

						var imgOptionToAppend = '' +
							'<div id="option_node_radio_div_'+response.option_node_id+'_'+response.values[i].val_id+'" class="radio imgOptionRadio'+assignment_key_prc_factor_class+assignment_key_prc_percent_class+'"'+dataValues+'>'+
								'<label id="product_config_label_' + id + '" class="product_config-img_picker" style="background-image: url(' + picturePath + response.values[i].img_path + ')" onMouseover="showBigPicture(\'' + response.values[i].img_path + '\', \'false\'' + ', \'' + escapeHtml(response.values[i].title) + '\');" onMouseout="hideBigPicture();">'+
									'<input '+
										'type="radio" '+
										'name="option_node_id_' + response.option_node_id + '" '+
										'id="product_config_button_id_' + id + '" '+
										'class="product_config_lvl_' + configLevel + '" '+
										'value="' + escapeHtml(response.values[i].title) + '" '+
										'onClick="processOptionValueSelection(' +
											response.option_node_id + ', ' +
											response.values[i].val_id + ', ' +
											'getUserInputValues(' + response.option_node_id + ', ' + response.values[i].val_id + '), ' +
                            				response.values[i].prc_from_csv + ', \'' +
											configLevel + '\', \'' +
											response.option_node_id + '\', \'' +
											'image\', '+
											id+
										'); '+
										'setInfoContent(\'' +
											response.title + '\', \'' +
											escapeHtml(response.values[i].title) + '\', \'' +
											response.option_node_id + '\', \'' +
											response.values[i].val_id + '\', \'' +
											response.values[i].price_chg + '\''+
										');"'+
									'>'+
								'</label>';
                        		if( checkOptionBitwise( _licOption, '0001000' ) ) {		// option:  0001000	=> user input
									imgOptionToAppend += getUserInputContent( response, i );
                                }
							imgOptionToAppend += '</div>';
						$ad_pc_jq_1_11_3("#product_config_lvl_" + configLevel).append( imgOptionToAppend );
                        if( checkOptionBitwise( _licOption, '0001000' ) ) {		// option:  0001000	=> user input
                            if (i < response.values.length - 1) {
                                var currentUserInputs1 = getUserInputValues(response.option_node_id, response.values[i].val_id);
                                if (currentUserInputs1.length > 0) {
                                    $ad_pc_jq_1_11_3("#product_config_lvl_" + configLevel).append('<div class="optionValueSeperator"></div>');
                                }
                            }
                        }

						// price
						if (response.values[i].price_chg != 0) {
							if (response.values[i].price_chg > 0) {
								$ad_pc_jq_1_11_3("#product_config_label_" + id).append(
                                    '<span class="product_config_info">' +
										'<span class="product_config_name">' + escapeHtml(response.values[i].title) + '</span> <span class="product_config_price">(' + _currencyString + ' +' + getPriceStr(response.values[i].price_chg * _discountMultiplier) + getUserInputPriceInfoExtra( response, i ) + ')</span>' +
									'</span>'
								);
							} else {
								$ad_pc_jq_1_11_3("#product_config_label_" + id).append(
                                    '<span class="product_config_info">' +
										'<span class="product_config_name">' + escapeHtml(response.values[i].title) + '</span> <span class="product_config_price">(' + _currencyString + ' ' + getPriceStr(response.values[i].price_chg * _discountMultiplier) + getUserInputPriceInfoExtra( response, i ) + ')</span>' +
                                	'</span>'
								);
							}
						}else {
							$ad_pc_jq_1_11_3("#product_config_label_" + id).append(
                                '<span class="product_config_info">' +
									'<span class="product_config_name">' + escapeHtml(response.values[i].title) + '</span>'+
                            	'</span>'
							);
						}

						// clear for colorpicker
						if (i == (response.values.length - 1)) {
							$ad_pc_jq_1_11_3("#product_config_lvl_" + configLevel).append(
								'<div class="clearfix color_picker"></div>'
							);
						}

						//setup the colorpicker
					} else if (response.values[i].color != '') {

						var colorOptionToAppend = '' +
							'<div id="option_node_radio_div_'+response.option_node_id+'_'+response.values[i].val_id+'" class="radio colorOptionRadio'+assignment_key_prc_factor_class+assignment_key_prc_percent_class+'"'+dataValues+'>'+
								'<label id="product_config_label_' + id + '" class="product_config-color_picker" style="background-color:#' + response.values[i].color + '" onMouseover="showBigPicture(\'' + response.values[i].img_path + '\', \'' + response.values[i].color + '\', \'' + escapeHtml(response.values[i].title) + '\');" onMouseout="hideBigPicture();">'+
									'<input '+
										'type="radio" '+
										'name="option_node_id_' + response.option_node_id + '" '+
										'id="product_config_button_id_' + id + '" '+
										'class="product_config_lvl_' + configLevel + '" '+
										'value="' + escapeHtml(response.values[i].title) + '" '+
										'onClick="processOptionValueSelection(' +
											response.option_node_id + ', ' +
											response.values[i].val_id + ', ' +
											'getUserInputValues(' + response.option_node_id + ', ' + response.values[i].val_id + '), ' +
                            				response.values[i].prc_from_csv + ', \'' +
                            				configLevel + '\', \'' +
											response.option_node_id + '\', \'' +
											'color\', '+
											id+
										'); ' +
										'setInfoContent(\'' +
											response.title + '\', \'' +
											escapeHtml(response.values[i].title) + '\', \'' +
											response.option_node_id + '\', \'' +
											response.values[i].val_id + '\', \'' +
											response.values[i].price_chg + '\'' +
										');"'+
									'>'+
								'</label>';
                        		if( checkOptionBitwise( _licOption, '0001000' ) ) {		// option:  0001000	=> user input
									colorOptionToAppend += getUserInputContent( response, i );
                                }
							colorOptionToAppend += '</div>';
						$ad_pc_jq_1_11_3("#product_config_lvl_" + configLevel).append( colorOptionToAppend );
                        if( checkOptionBitwise( _licOption, '0001000' ) ) {		// option:  0001000	=> user input
                            if (i < response.values.length - 1) {
                                var currentUserInputs2 = getUserInputValues(response.option_node_id, response.values[i].val_id);
                                if (currentUserInputs2.length > 0) {
                                    $ad_pc_jq_1_11_3("#product_config_lvl_" + configLevel).append('<div class="optionValueSeperator"></div>');
                                }
                            }
                        }

						// price
						if (response.values[i].price_chg != 0) {
							if (response.values[i].price_chg > 0) {
								$ad_pc_jq_1_11_3("#product_config_label_" + id).append(
									'<span class="product_config_info">' +
										'<span class="product_config_name">' + escapeHtml(response.values[i].title) + '</span> <span class="product_config_price">(' + _currencyString + ' +' + getPriceStr(response.values[i].price_chg * _discountMultiplier) + getUserInputPriceInfoExtra( response, i ) + ')</span>' +
									'</span>'
								);
							} else {
								$ad_pc_jq_1_11_3("#product_config_label_" + id).append(
                                    '<span class="product_config_info">' +
										'<span class="product_config_name">' + escapeHtml(response.values[i].title) + '</span> <span class="product_config_price">(' + _currencyString + ' ' + getPriceStr(response.values[i].price_chg * _discountMultiplier) + getUserInputPriceInfoExtra( response, i ) +')</span>' +
                                    '</span>'
								);
							}
						}else {
							$ad_pc_jq_1_11_3("#product_config_label_" + id).append(
                                '<span class="product_config_info">' +
									'<span class="product_config_name">' + escapeHtml(response.values[i].title) + '</span>'+
                                '</span>'
							);
						}

						// clear for colorpicker
						if (i == (response.values.length - 1)) {
							$ad_pc_jq_1_11_3("#product_config_lvl_" + configLevel).append(
								'<div class="clearfix color_picker"></div>'
							);
						}

						// setup normal options
					} else {
						var ad_pc_ass_key_prc_fact = "";
						var normalOptionToAppend = '' +
							'<div id="option_node_radio_div_'+response.option_node_id+'_'+response.values[i].val_id+'" class="radio normalOptionRadio'+assignment_key_prc_factor_class+assignment_key_prc_percent_class+'"'+dataValues+'>'+
								'<label class="value_title">'+
									'<input '+
										'type="radio" '+
										'name="' + response.title + '-' + configLevel + '" '+
										'id="product_config_radio_id_' + id + '" '+
										'class="product_config_lvl_' + configLevel + '" '+
										'value="' + escapeHtml(response.values[i].title) + '" '+
										'onClick="processOptionValueSelection(' +
											response.option_node_id + ', ' +
											response.values[i].val_id + ', ' +
											'getUserInputValues(' + response.option_node_id + ', ' + response.values[i].val_id + '), ' +
                            				response.values[i].prc_from_csv + ', \'' +
                            				configLevel + '\', \'' +
											response.option_node_id + '\', \'' +
											'radio\', '+
											id+
										'); '+
										'setInfoContent(\'' +
											response.title + '\', \'' +
											escapeHtml(response.values[i].title) + '\', \'' +
											response.option_node_id + '\', \'' +
											response.values[i].val_id + '\', \'' +
											response.values[i].price_chg + '\''+
										');"'+
									'>' +
									escapeHtml(response.values[i].title) +
									'<span id="product_config_price_' + id + '" class="product_config_price"></span>'+
								'</label>';
                        		if( checkOptionBitwise( _licOption, '0001000' ) ) {		// option:  0001000	=> user input
									normalOptionToAppend += getUserInputContent( response, i );
                                }
							normalOptionToAppend += '</div>';
						$ad_pc_jq_1_11_3("#product_config_lvl_" + configLevel).append( normalOptionToAppend );
                        if( checkOptionBitwise( _licOption, '0001000' ) ) {		// option:  0001000	=> user input
                            if (i < response.values.length - 1) {
                                var currentUserInputs3 = getUserInputValues(response.option_node_id, response.values[i].val_id);
                                if (currentUserInputs3.length > 0) {
                                    $ad_pc_jq_1_11_3("#product_config_lvl_" + configLevel).append('<div class="optionValueSeperator"></div>');
                                }
                            }
                        }

						// price
						if (response.values[i].price_chg != 0 && !response.values[i].prc_from_csv) {
							if (response.values[i].price_chg > 0) {
								var priceTitlePrint = priceTitle != '' ? priceTitle + ' ' : priceTitle;
								$ad_pc_jq_1_11_3("#product_config_price_" + id).append(
									'(' + priceTitlePrint + _currencyString + ' +' + getPriceStr(response.values[i].price_chg * _discountMultiplier) + getUserInputPriceInfoExtra( response, i ) + ')'
								);
							} else {
								var priceNegativeTitlePrint = priceNegativeTitle != '' ? priceNegativeTitle + ' ' : priceNegativeTitle;
								$ad_pc_jq_1_11_3("#product_config_price_" + id).append(
									'(' + priceNegativeTitlePrint + _currencyString + ' ' + getPriceStr(response.values[i].price_chg * _discountMultiplier) + getUserInputPriceInfoExtra( response, i ) + ')'
								);
							}
						}

					}
					id++;
				}

				configLevel++;
			} else if (response.is_leaf === true) {
				handleFinishedConfig();
			}

			// handle radio elements when user inputs exist
            if( checkOptionBitwise( _licOption, '0001000' ) ) {		// option:  0001000	=> user input
                $ad_pc_jq_1_11_3('input[id^="product_config_"]').each(function () {
                    var inputColExisting = false;
                    var optionValueRadio = $ad_pc_jq_1_11_3(this);
                    var optValRadioId = optionValueRadio.attr('id');
                    var nodeDiv = optionValueRadio.parent().parent().parent();
                    var parentOptNodeRadioDivs = nodeDiv.find('div[id^="option_node_radio_div_"]');
                    parentOptNodeRadioDivs.each(function () {
                        var parentOptionNodeRadioDiv = $ad_pc_jq_1_11_3(this);
                        if (parentOptionNodeRadioDiv.find('div[id^="user_input_col_div_"]').length > 0) {
                            inputColExisting = true;
                        }
                    });
                    if (inputColExisting) {
                        var userInputValueIds = new Array();
                        parentOptNodeRadioDivs.each(function () {
                            if (optionValueRadio.attr('type') == 'radio') {
                                var parentOptionNodeRadioDiv = $ad_pc_jq_1_11_3(this);
                                var optNRDId = String(parentOptionNodeRadioDiv.attr('id'));
                                var delPos = optNRDId.lastIndexOf('_');
                                if (optNRDId.length > delPos + 1) {
                                    var optNodeId = optNRDId.substr(delPos + 1);
                                    optNRDId = optNRDId.substr(0, delPos);
                                    delPos = optNRDId.lastIndexOf('_');
                                    if (optNRDId.length > delPos + 1) {
                                        var valId = optNRDId.substr(delPos + 1);
                                        var btnId = 'ad_pc_opt_val_sel_btn_' + optNodeId + '_' + valId;
                                        if ($ad_pc_jq_1_11_3('#' + btnId).length <= 0) {
                                        	var buttonText = _i18n.translate("continue").fetch();
                                            if( checkOptionBitwise( _licOption, '0000010' ) ) {		// option:  0000010	=> text exclusive
                                        		buttonText = _i18n.translate("OK").fetch();
											}
                                            var selectButton = '<button type="button" class="button opt_val_sel_btn" id="' + btnId + '" onclick="triggerOptValClick(this)">' + buttonText + '</button>';
                                            // if the option value has user inputs the "next"-button is inside the user input div
                                            var divToAppendBtn = parentOptionNodeRadioDiv.find('div[id^=user_input_col_div_]');
                                            if (divToAppendBtn.length <= 0) {
                                                divToAppendBtn = parentOptionNodeRadioDiv;
                                            }
                                            divToAppendBtn.append(selectButton);

                                            // fill list for user inputs to check initial values for
                                            var uInInputVal = parentOptionNodeRadioDiv.find('div.user_input_col_div').find('div.user_input_div').find('.ad_pc_usr_inp_val');
                                            var uInInputValIdStr = String(uInInputVal.attr('id'));
                                            var lastIndexOfSep = uInInputValIdStr.lastIndexOf('_');
                                            if (lastIndexOfSep >= 0) {
                                                userInputValueIds.push(uInInputValIdStr.substr(lastIndexOfSep + 1));
                                            }
                                        }
                                        optionValueRadio.css('display', 'none');
                                    }
                                }
                            }
                        });
                        for (var uIVIIndex = 0; uIVIIndex < userInputValueIds.length; uIVIIndex++) {
                            var userInputOk = checkUserInputValidity(userInputValueIds[uIVIIndex], false);
                            setUserInputConfirmButtonEnabledState(userInputValueIds[uIVIIndex], userInputOk);
                        }
                    }
                });
            }
		}
		if( configStartSuccess ) {
			if (typeof(adOptions) !== 'undefined' && adOptions.configDivId && adOptions.configDivId != '') {
				$ad_pc_jq_1_11_3("#" + adOptions.configDivId).fadeIn(1000);
            }
		}
        if( _adPcUserInputExisting && !checkOptionBitwise( _licOption, '0001000' ) ) {		// option:  0001000	=> user input
			var configuratorDiv = $ad_pc_jq_1_11_3("#ad_pc_config_content_info").parent('div');
			var licErrorDiv = configuratorDiv.find('#ad_pc_lic_error_div');
			if( licErrorDiv.length <= 0 ) {
				licErrorDiv = $ad_pc_jq_1_11_3(document.createElement('div'));
				licErrorDiv.attr('id', 'ad_pc_lic_error_div');
				var licErrorParagraph = $ad_pc_jq_1_11_3(document.createElement('p'));
				licErrorParagraph.html(_i18n.translate("license_not_suitable_for_user_input_message").fetch());
				licErrorDiv.append(licErrorParagraph);
				configuratorDiv.prepend(licErrorDiv);
			}
        }
	}
}

function handleTax( price ) {
	if ( !_pricesIncludeTax ) {
		return ( price / (100.0 + _taxValue) ) * 100.0;
	}
	return price;
}

function triggerOptValClick( selectButton ) {
	var selBtn = $ad_pc_jq_1_11_3(selectButton);
	var selBtnParent = selBtn.parent();
	// if the option value has user inputs the "next"-button is inside the user input div
	if( selBtnParent.attr('id').startsWith('user_input_col_div_')  ) {
		selBtnParent = selBtnParent.parent();
	}
	var inputToSelect = selBtnParent.find('input[id^="product_config_"]');
	inputToSelect.prop('checked', true);
	inputToSelect.click();
}

function getUserInputContent( response, valueIndex ) {
	var userInputContent = '';
	if( response.values[valueIndex].usr_inp_col != '' ) {
		var uInpCol = response.values[valueIndex].usr_inp_col;
		if( Object.prototype.toString.call( uInpCol.user_inputs ) === '[object Array]' &&
			uInpCol.user_inputs.length > 0 ) {
			userInputContent += '' +
				'<div id="user_input_col_div_'+uInpCol.id+'" class="user_input_col_div">';
			for (var uinpIndex = 0; uinpIndex < uInpCol.user_inputs.length; uinpIndex++) {
				var uInpOut = '' +
					'<label class="ad_pc_usr_inp_title">' +
						uInpCol.user_inputs[uinpIndex].title +
					'</label>';
				if( uInpCol.user_inputs[uinpIndex].input_type == 3 ) {		// if text input field -> create a text area
					uInpOut += '<textarea '+
						'id="ad_pc_opt_val_uinp_chosen_'+uInpCol.user_inputs[uinpIndex].id+'" '+
						'class="ad_pc_usr_inp_val" '+
						'name="ad_pc_uinp_'+uInpCol.user_inputs[uinpIndex].id+'" '+
						'oninput="adPcOnInputUserInputContent(\''+uInpCol.id+'\', \''+uInpCol.col_type+'\', \''+uInpCol.user_inputs[uinpIndex].id+'\')" '+
						'value=""'+
					'></textarea>';
				}
				else {														// if number input -> create an input
					uInpOut += '<input '+
						'id="ad_pc_opt_val_uinp_chosen_'+uInpCol.user_inputs[uinpIndex].id+'" '+
						'class="ad_pc_usr_inp_val" '+
						'type="text" '+
						'name="ad_pc_uinp_'+uInpCol.user_inputs[uinpIndex].id+'" '+
						'oninput="adPcOnInputUserInputContent(\''+uInpCol.id+'\', \''+uInpCol.col_type+'\', \''+uInpCol.user_inputs[uinpIndex].id+'\')" '+
						'value=""'+
					'>';
				}
				if( uInpCol.user_inputs[uinpIndex].unit != '' ) {
					uInpOut += '<label class="ad_pc_usr_inp_unit">' + uInpCol.user_inputs[uinpIndex].unit + '</label>';
				}
				uInpOut += '<input id="ad_pc_uinp_col_type_'+uInpCol.id+'" type="hidden" value="'+uInpCol.col_type+'">';
				uInpOut += '<input id="ad_pc_uinp_input_type_'+uInpCol.user_inputs[uinpIndex].id+'" type="hidden" value="'+uInpCol.user_inputs[uinpIndex].input_type+'">';

				var usrInpDecCount = parseInt(uInpCol.user_inputs[uinpIndex].decimal_count);

				var usrInpMin = String(uInpCol.user_inputs[uinpIndex].min);
				if( usrInpMin != '' && !isNaN(usrInpDecCount) && usrInpDecCount > 0 ) {
					usrInpMin = usrInpMin.substr(0, usrInpMin.length - usrInpDecCount) + '.' + usrInpMin.substr(usrInpMin.length - usrInpDecCount);
				}

				var usrInpMax = String(uInpCol.user_inputs[uinpIndex].max);
				if( usrInpMax != '' && !isNaN(usrInpDecCount) && usrInpDecCount > 0 ) {
					usrInpMax = usrInpMax.substr(0, usrInpMax.length - usrInpDecCount) + '.' + usrInpMax.substr(usrInpMax.length - usrInpDecCount);
				}

				var usrInpStepSize = String(uInpCol.user_inputs[uinpIndex].step_size);
				if( usrInpStepSize != '' && !isNaN(usrInpDecCount) && usrInpDecCount > 0 ) {
					usrInpStepSize = usrInpStepSize.substr(0, usrInpStepSize.length - usrInpDecCount) + '.' + usrInpStepSize.substr(usrInpStepSize.length - usrInpDecCount);
				}

				uInpOut += '<input id="ad_pc_uinp_decimal_count_'+uInpCol.user_inputs[uinpIndex].id+'" type="hidden" value="'+String(usrInpDecCount)+'">';
				uInpOut += '<input id="ad_pc_uinp_min_'+uInpCol.user_inputs[uinpIndex].id+'" type="hidden" value="'+usrInpMin+'">';
				uInpOut += '<input id="ad_pc_uinp_max_'+uInpCol.user_inputs[uinpIndex].id+'" type="hidden" value="'+usrInpMax+'">';
				uInpOut += '<input id="ad_pc_uinp_step_size_'+uInpCol.user_inputs[uinpIndex].id+'" type="hidden" value="'+usrInpStepSize+'">';

				var uInpInfoOut = '';
				if( usrInpMin != '' || usrInpMax != '' || usrInpStepSize != '' ) {
					if( usrInpMin != '' ) {
						uInpInfoOut +=  _i18n.translate("min").fetch() + ': ' + usrInpMin;
					}
					if( usrInpMax != '' ) {
						if( uInpInfoOut != '' ) {
							uInpInfoOut += '; ';
						}
						uInpInfoOut += _i18n.translate("max").fetch() + ': ' + usrInpMax;
					}
					if( usrInpStepSize != '' ) {
						if( uInpInfoOut != '' ) {
							uInpInfoOut += '; ';
						}
						uInpInfoOut += _i18n.translate("step size").fetch() + ': ' + usrInpStepSize;
					}
				}

				userInputContent += '' +
					'<div class="user_input_div">' + uInpOut + '</div>';
				if( uInpInfoOut != '' ) {
					userInputContent += '' +
						'<p id="ad_pc_user_input_info_' + uInpCol.user_inputs[uinpIndex].id + '" class="ad_pc_user_input_info">' + uInpInfoOut + '</p>';
				}
			}
			// if collection type equals Area (5), Volume (6), Circle diameter (7) or Circle perimeter (8)
			if( uInpCol.col_type == 5 || uInpCol.col_type == 6 ||
                uInpCol.col_type == 7 || uInpCol.col_type == 8 ) {
				var uInpCalcOut = '' +
					'<p>' +
						'<div id="ad_pc_calc_uinpcol_'+uInpCol.id+'" class="ad_pc_calc_uinpcol">' +
							'<label class="ad_pc_calc_uinpcol_title_label">';
				if( uInpCol.col_type == 5 ) {
					uInpCalcOut += _i18n.translate("Area").fetch() + ': ';
				}
				else if( uInpCol.col_type == 6 ) {
					uInpCalcOut += _i18n.translate("Volume").fetch() + ': ';
				}
				else if( uInpCol.col_type == 7 ) {
                    uInpCalcOut += _i18n.translate( "Area" ).fetch() + ': ';
                }
                else if( uInpCol.col_type == 8 ) {
                    uInpCalcOut += _i18n.translate( "Area" ).fetch() + ': ';
                }

				uInpCalcOut += '' +
							'</label>' +
							'<label id="ad_pc_calc_label_uinpcol_'+uInpCol.id+'" class="ad_pc_calc_label_uinpcol">0</label>' +
							'<label class="ad_pc_calc_uinpcol_unit_label">';
				if( uInpCol.user_inputs[0].unit != '' ) {
					uInpCalcOut += ' ' + uInpCol.user_inputs[0].unit;
					if( uInpCol.col_type == 5 ) {
						uInpCalcOut += '</label><label class="ad_pc_calc_uinpcol_unit_val_label">' + '<sup>' + '2' + '</sup></label>';
					}
					else if( uInpCol.col_type == 6 ) {
						uInpCalcOut += '</label><label class="ad_pc_calc_uinpcol_unit_val_label">' + '<sup>' + '3' + '</sup></label>';
					}
					else if( uInpCol.col_type == 7 ) {
                        uInpCalcOut += '</label><label class="ad_pc_calc_uinpcol_unit_val_label">' + '<sup>' + '2' + '</sup></label>';
                    }
                    else if( uInpCol.col_type == 8 ) {
                        uInpCalcOut += '</label><label class="ad_pc_calc_uinpcol_unit_val_label">' + '<sup>' + '2' + '</sup></label>';
                    }
                }
				uInpCalcOut += '' +
							'</label>' +
							'<input '+
								'id="ad_pc_uinp_calc_chosen_'+response.option_node_id+'" '+
								'type="hidden" '+
								'name="ad_pc_calc_uinp_col'+uInpCol.id+'" '+
								'value=0'+
							'>'+
						'</div>' +
					'</p>';
				userInputContent += uInpCalcOut;
			}
			userInputContent += '' +
				'</div>';
		}
	}
	if( _csvPriceChgC.prc_chg ) {
        setInfoContent(_csvPriceChgC.setInfoContent_name, _csvPriceChgC.setInfoContent_value, _csvPriceChgC.node_id, _csvPriceChgC.value_id, _csvPriceChgC.prc_chg);
        resetCsvPriceChgC();		// all things done to handle the price from CSV for the info content part - time to reset the temporary stored values
	}
	return userInputContent;
}

function getUserInputPriceInfoExtra( response, valueIndex ) {
	var userInputPriceInfoExtra = '';
	if( response.values[valueIndex].usr_inp_col != '' ) {
        var uInpCol = response.values[valueIndex].usr_inp_col;
        if (Object.prototype.toString.call(uInpCol.user_inputs) === '[object Array]' &&
            uInpCol.user_inputs.length > 0) {
        	if( uInpCol.user_inputs[0].unit != '' ) {
        		userInputPriceInfoExtra += ' ' + _i18n.translate("per").fetch() + ' ' + uInpCol.user_inputs[0].unit;
				if( uInpCol.col_type == 5 ) {
					userInputPriceInfoExtra += '<sup>' + '2' + '</sup>';
				}
				else if( uInpCol.col_type == 6 ) {
					userInputPriceInfoExtra += '<sup>' + '3' + '</sup>';
				}
				else if( uInpCol.col_type == 7 ) {
                    userInputPriceInfoExtra += '<sup>' + '2' + '</sup>';
                }
                else if( uInpCol.col_type == 8 ) {
                    userInputPriceInfoExtra += '<sup>' + '2' + '</sup>';
                }
            }
        }
    }
    return userInputPriceInfoExtra;
}

function getUserInputValues( option_node_id, value_id ) {
	var userValuesArray = new Array();
	var parentDiv = $ad_pc_jq_1_11_3("#option_node_radio_div_"+option_node_id+'_'+value_id);
	var uInpColDiv = parentDiv.find('div[id^="user_input_col_div_"]');
	uInpColDiv.find('.user_input_div').each(function(){
		var uInpDiv = $ad_pc_jq_1_11_3(this);
		var uInpParentColType = uInpDiv.find('input[id^=ad_pc_uinp_col_type_]');
		var uInpInput = uInpDiv.find('input');
		var uInpVal = uInpInput.val();
		// if collection type equals Number(2 or 3 or 4), Area (5) or Volume (6)
    	if (String(uInpParentColType) == '2' || String(uInpParentColType) == '3' || String(uInpParentColType) == '4' ||
			String(uInpParentColType) == '5' ||
			String(uInpParentColType) == '6') {
			uInpVal = convertToNumberString(uInpVal);			// get valid number representation or '' if no number
        }
		userValuesArray.push(uInpVal);
	});

	return userValuesArray;
}

function adPcOnInputUserInputContent(uInpColId, uInpColType, userInputValueId) {
    // if collection type equals Area (5) or Volume (6)
    if (String(uInpColType) == '5' || String(uInpColType) == '6') {
        var uInpInputVals = new Array();
        var uInpColDiv = $ad_pc_jq_1_11_3('#user_input_col_div_' + uInpColId);
        var uInpDivCount = 0;
        uInpColDiv.find('div.user_input_div').each(function () {
            uInpDivCount++;
            var uInpDiv = $ad_pc_jq_1_11_3(this);
            var uInpInput = uInpDiv.find('input');
            var uInpInputVal = uInpInput.val();
            uInpInputVal = convertToNumberString(uInpInputVal);
            if (uInpInputVal != '') {
                uInpInputVals.push(uInpInputVal);
            }
        });

        var uInpColCalcDiv = uInpColDiv.find('div.ad_pc_calc_uinpcol');
        var uInpColCalcLabel = uInpColCalcDiv.find('label.ad_pc_calc_label_uinpcol');
        var uInpColCalcInput = uInpColCalcDiv.find('input');
        if( uInpInputVals.length > 1 && uInpInputVals.length == uInpDivCount ) {
        	var calcResult = uInpInputVals[0];
        	for( var uInpVIndex = 1; uInpVIndex < uInpInputVals.length; uInpVIndex++ ) {
        		calcResult = calcResult * uInpInputVals[uInpVIndex];
			}
        	uInpColCalcLabel.text(calcResult.toFixed(2))
        	uInpColCalcInput.val(calcResult);
		}
		else {
        	uInpColCalcLabel.text(0);
        	uInpColCalcInput.val(0);
		}
    }
    // else if collection type equals Circle diameter (7) or Circle perimeter (8)
    else if( String( uInpColType ) == '7' || String( uInpColType ) == '8' ) {
        var uInpColDiv = $ad_pc_jq_1_11_3( '#user_input_col_div_' + uInpColId );
        var uInpDiv = uInpColDiv.find( 'div.user_input_div' );
        var uInpInput = uInpDiv.find( 'input' );
        var uInpInputVal = uInpInput.val();
        uInpInputVal = convertToNumberString( uInpInputVal );
        var uInpColCalcDiv = uInpColDiv.find( 'div.ad_pc_calc_uinpcol' );
        var uInpColCalcLabel = uInpColCalcDiv.find( 'label.ad_pc_calc_label_uinpcol' );
        var uInpColCalcInput = uInpColCalcDiv.find( 'input' );
        if( uInpInputVal != '' ) {
            var calcResult = 0;
            if( String( uInpColType ) == '7' ) {		// Circle diameter
                calcResult = Math.PI * Math.pow( (uInpInputVal / 2.0), 2 );		// A = PI * r^2		(r = Radius; uInpInputVal = Durchmesser; r = uInpInputVal / 2 )
			}
            else if( String( uInpColType ) == '8' ) {	// Circle perimeter
                calcResult = Math.pow( uInpInputVal, 2 ) / ( 4 * Math.PI );		// A = u^2 / 4*PI	(u = Umfang; uInpInputVal = Umfang)
            }
            uInpColCalcLabel.text( calcResult.toFixed( 2 ) )
            uInpColCalcInput.val( calcResult );
        }
        else {
            uInpColCalcLabel.text(0);
            uInpColCalcInput.val(0);
		}
    }

    var userInputOk = checkUserInputValidity(userInputValueId, true);
    setUserInputConfirmButtonEnabledState(userInputValueId, userInputOk);
}

function checkUserInputValidity( userInputValueId, checkSiblingsToo ) {
	var cInputOk = true;
	if( checkSiblingsToo ) {
		var userInputDivs = $ad_pc_jq_1_11_3('#ad_pc_opt_val_uinp_chosen_'+userInputValueId).closest('div.user_input_col_div').find('div.user_input_div');
		userInputDivs.each(function () {
			var cUIInputVal = $ad_pc_jq_1_11_3(this).find('.ad_pc_usr_inp_val');
			var cUILI = String(cUIInputVal.attr('id')).lastIndexOf('_');
			if( cUILI >= 0 ) {
				var cUIndex = String(cUIInputVal.attr('id')).substr(cUILI + 1);
				if( cUIndex != userInputValueId ) {
					cInputOk = checkUserInputValidity(cUIndex, false);
				}
			}
        });
	}
	if( !cInputOk ) {
		return false;
	}

	var usrInpType = String($ad_pc_jq_1_11_3('#ad_pc_uinp_input_type_'+userInputValueId).val());
    if( usrInpType === '1' || usrInpType === '2' ) {		// type number -> 1, type decimal -> 2, type text -> 3
		var uInpValCurrent = String($ad_pc_jq_1_11_3('#ad_pc_opt_val_uinp_chosen_'+userInputValueId).val());
		var uInpValCurrentOrg = uInpValCurrent;
		uInpValCurrent = convertToNumberString(uInpValCurrent);

		var usrInpMin = parseFloat($ad_pc_jq_1_11_3('#ad_pc_uinp_min_'+userInputValueId).val());
		var usrInpMax = parseFloat($ad_pc_jq_1_11_3('#ad_pc_uinp_max_'+userInputValueId).val());
		// if the current user input converted to a number is not empty
		if( uInpValCurrent !== '' ) {
			var usrInpDecCount = parseFloat( $ad_pc_jq_1_11_3('#ad_pc_uinp_decimal_count_'+userInputValueId).val() );
			var decimalCount = getDecimalPlacesCount( uInpValCurrent );
			// user input has to many decimal places
			if( !isNaN(usrInpDecCount) && decimalCount > usrInpDecCount ) {
				return false;
			}

			var usrInpStepSize = parseFloat($ad_pc_jq_1_11_3('#ad_pc_uinp_step_size_'+userInputValueId).val());

			uInpValCurrent = parseFloat(uInpValCurrent);

			// user input is below the min value
			if( !isNaN(usrInpMin) && uInpValCurrent < usrInpMin ) {
				return false;
			}

			// user input is above the max value
			if( !isNaN(usrInpMax) && uInpValCurrent > usrInpMax ) {
				return false;
			}

			if( !isNaN(usrInpStepSize) ) {
				var forModuloMult = 1;
				if( usrInpDecCount > 0 ) {
					forModuloMult = Math.pow(10, usrInpDecCount);
				}
				var stepsMin = !isNaN(usrInpMin) ? parseInt(usrInpMin * forModuloMult) : 0;
				var uInpValSteps = parseInt( (uInpValCurrent  * forModuloMult) - stepsMin );
				var stepsModuloVal = uInpValSteps % parseInt(usrInpStepSize * forModuloMult);
				// user input is not inside the alowed steps definition
				if( stepsModuloVal != 0 ) {
					return false;
				}
			}
		}
		// if the current user input converted to a number is empty
		else {
			// if the original user input is not the empty string return false
			if( uInpValCurrentOrg !== '' ) {
				return false;
			}
			// if either user input min or user input max are defined return false
			else if( !isNaN(usrInpMin) || !isNaN(usrInpMax) ) {
				return false;
			}
			// if the original user input is empty and neither min nor max are specified all is good (user input is ok)
		}
	}
	return true;
}

function setUserInputConfirmButtonEnabledState( userInputValueId, enable ) {
	var inpColDiv = $ad_pc_jq_1_11_3('#ad_pc_opt_val_uinp_chosen_'+userInputValueId).closest('div[id^=user_input_col_div_]');
	var selBtn = inpColDiv.find('button.opt_val_sel_btn');
	selBtn.prop('disabled', !enable);

	var optNodeRadioDiv = $ad_pc_jq_1_11_3('#ad_pc_opt_val_uinp_chosen_'+userInputValueId).closest('div[id^=option_node_radio_div_]');
	var prodConfLabel = optNodeRadioDiv.find('label[id^=product_config_label_]');
	if( prodConfLabel.length > 0 ) {
		var prodConfBtnInput = prodConfLabel.find('input[id^=product_config_button_id_]');
		if( prodConfBtnInput.length > 0 ) {
			prodConfBtnInput.prop('disabled', !enable);
		}
	}
}

function convertToNumberString( val ) {
	var valAsString = String(val);
	valAsString = valAsString.replace(',', '.');
	if( valAsString.length > 0 ) {
		if( valAsString.charAt(valAsString.length - 1) === '.' ) {		// check if the last char is '.' because the test below fails on that one
			return '';
		}
	}
	if( isFinite(String(valAsString).trim() || NaN) ) {					// checks if string is a number
		return parseFloat(valAsString);
	}
	return '';
}

function getDecimalPlacesCount( val ) {
	var valAsString = String(val);
	valAsString = valAsString.replace(',', '.');
	if( valAsString.length > 0 ) {
		var decimalPlaceIndex = valAsString.indexOf('.');
		if( decimalPlaceIndex < 0 ) {
			return 0;
		}
		else {
			return (valAsString.length - decimalPlaceIndex - 1);
		}
    }
}

//handle configuration
function checkConfigLvl(lvl, radioName, rType, id) {
	lvl = parseInt(lvl);
	configFinished = false;
	if( _ad_pc_version_running == AD_PC_VERSION_STANDALONE ) {
		$ad_pc_jq_1_11_3('#final_config_button').remove();
	}

	if (radioName != undefined) {
		var parentDiv = $ad_pc_jq_1_11_3("#product_config_lvl_" + lvl);
		parentDiv.find("input[name^='option_node_id_']").parent().removeClass("active");
		parentDiv.find("input[name^='option_node_id_']").parent().addClass("deactivated");
		$ad_pc_jq_1_11_3("#product_config_lvl_" + lvl).find("input:radio[id^='product_config_radio_id_']").each(function(i, v) {
			var selBtnParentDiv = $ad_pc_jq_1_11_3(this).parent().parent();
			var btnForThisOption = selBtnParentDiv.find('button[id^=ad_pc_opt_val_sel_btn_]');
			// if the radio is not the one selected at the moment
			if( $ad_pc_jq_1_11_3(this).attr('id') != 'product_config_radio_id_' + id ) {
				// uncheck it
				$ad_pc_jq_1_11_3(this).prop('checked', false);
				// visually uncheck it's button
				btnForThisOption.removeClass('opt_val_sel_btn_selected');
				// also update its parent div
				selBtnParentDiv.removeClass('opt_val_sel_btn_selected');
			}
			// if the radio is the one selected at the moment
			else {
				// visually check its button
				btnForThisOption.addClass('opt_val_sel_btn_selected');
				// also update its parent div
				selBtnParentDiv.addClass('opt_val_sel_btn_selected');
			}

		});
		if (rType == 'image' || rType == 'color') {
			if ($ad_pc_jq_1_11_3("input[name='option_node_id_" + radioName + "']:checked").prop('checked') == true) {
				$ad_pc_jq_1_11_3("input[name='option_node_id_" + radioName + "']:checked").parent().addClass("active");
				$ad_pc_jq_1_11_3("input[name='option_node_id_" + radioName + "']:checked").parent().removeClass("deactivated");
			}
		}
	}

	if (lvl >= (configLevel - 1)) {
		lock = false;
		return true;
	} else {
		var i = 0;
		for (i = (lvl + 1); i <= configLevel; i++) {
			$ad_pc_jq_1_11_3("#product_config_lvl_" + i).remove();
			delete prices[i];
			$ad_pc_jq_1_11_3("#info_content_final_price").html(_i18n.translate("Total Price").fetch() + ': ' + _currencyString + ' ' + getFinalSurcharge(prices));
		}
		configLevel = (lvl + 1);
		configFinished = false;
		lock = false;
		return true;
	}
}

//set info content
function setInfoContent(name, value, nodeId, valueId, price) {
	// if the price comes from a CSV-file remember the name and value only and do not set anything now - just return
	if( _csvPriceChgC.setInfoContent ) {
		_csvPriceChgC.setInfoContent_name = name;
		_csvPriceChgC.setInfoContent_value = value;
		_csvPriceChgC.setInfoContent = false;
		return;
	}

	var priceMultiplierUserInput = 1.0;
	var usrInpOutputInfo = '';
	var optNodeRadioDiv = $ad_pc_jq_1_11_3('#option_node_radio_div_'+nodeId+'_'+valueId );
	var usrInpColDiv = optNodeRadioDiv.find('div[id^=user_input_col_div_]');
	var usrInpColTypeDiv = usrInpColDiv.find('input[id^=ad_pc_uinp_col_type_]');
	var usrInpColType = usrInpColTypeDiv.val();
	if( usrInpColDiv.length > 0 ) {
		// retrieve price multiplier - but only do so if the price does not come from a CSV-file as this is a final price then
		if( !_csvPriceChgC.useCsvPriceOnly ) {
            var usrInpColCalcInput = usrInpColDiv.find('input[id^=ad_pc_uinp_calc_chosen_]');
            // if a calculated value exists use it for the price multiplier
            if (usrInpColCalcInput.length > 0) {
                priceMultiplierUserInput = convertToNumberString(usrInpColCalcInput.val());
                if (priceMultiplierUserInput == '') {
                    priceMultiplierUserInput = 0.0;
                }
            }
            // if no calculated value exists use the input value itself for the price multiplier
            else {
                // if collection type equals Number(2 or 3 or 4)
                if (String(usrInpColType) == '2' || String(usrInpColType) == '3' || String(usrInpColType) == '4') {
                    var usrValInput = usrInpColDiv.find('input[id^=ad_pc_opt_val_uinp_chosen_]');
                    priceMultiplierUserInput = convertToNumberString(usrValInput.val());
                    if (priceMultiplierUserInput == '') {
                        priceMultiplierUserInput = 0.0;
                    }
                }
            }
		}

		// create user input output information
		if( usrInpColDiv.length > 0 ) {
			var usrInpOutputInfo = getUserInputCollectionOutput( usrInpColDiv );
            if (usrInpOutputInfo != '') {
                value = String(value) + ' ' + usrInpOutputInfo;
            }
        }
	}

	if ($ad_pc_jq_1_11_3("#info_content_id_" + nodeId).length > 0) {
		var indexNodeId = infoContentEntryArray.indexOf(nodeId);
		var infoCLength = infoContentEntryArray.length;
		for( var i = infoCLength - 1; i >= indexNodeId; i-- ) {
			$ad_pc_jq_1_11_3("#info_content_id_" + infoContentEntryArray[i]).remove();
			delete prices[infoContentEntryArray[i]];
			delete configuration[infoContentEntryArray[i]];
		}
		infoContentEntryArray.splice(indexNodeId, infoCLength - indexNodeId);
	}
	if ($ad_pc_jq_1_11_3("#info_content_hr").length > 0) {
		$ad_pc_jq_1_11_3("#info_content_hr").remove();
	}
	if (price != 0 && $ad_pc_jq_1_11_3("#info_content_final_price").length > 0) {
		$ad_pc_jq_1_11_3("#info_content_final_price").remove();
	}

	if (price == 0) {
		$ad_pc_jq_1_11_3('#info_content_ul').append(
			'<li id="info_content_id_' + nodeId + '" class="list-group-item"><span class="info_content_title">' + name + ': </span><span class="info_content_value">' + value + '</span></li>'
		);
		infoContentEntryArray.push(nodeId);
		configuration[(nodeId - 1)] = {
			id: (nodeId - 1),
			name: name,
			value: value,
			price: price
		}
	} else {
		price = price * priceMultiplierUserInput;
		if (price >= 0) {
			var priceTitlePrint = priceTitle != '' ? priceTitle + ' ' : priceTitle;
			$ad_pc_jq_1_11_3('#info_content_ul').append(
				'<li id="info_content_id_' + nodeId + '" class="list-group-item"><span class="info_content_title">' + name + ': </span><span class="info_content_value">' + value + '</span><span id="' + price + '" class="badge price">' + priceTitlePrint + _currencyString + ' +' + getPriceStr(price * _discountMultiplier) + '</li>'
			);
			infoContentEntryArray.push(nodeId);
		} else if (price < 0) {
			var priceNegativeTitlePrint = priceNegativeTitle != '' ? priceNegativeTitle + ' ' : priceNegativeTitle;
			$ad_pc_jq_1_11_3('#info_content_ul').append(
				'<li id="info_content_id_' + nodeId + '" class="list-group-item"><span class="info_content_title">' + name + ': </span><span class="info_content_value">' + value + '</span><span id="' + price + '" class="badge price">' + priceNegativeTitlePrint + _currencyString + ' ' + getPriceStr(price * _discountMultiplier) + '</li>'
			);
			infoContentEntryArray.push(nodeId);
		}

		prices[nodeId] = price;
		configuration[(nodeId - 1)] = {
			id: (nodeId - 1),
			name: name,
			value: value,
			price: price
		}
	}

	$ad_pc_jq_1_11_3(infoDiv).append(
		'<hr id="info_content_hr">'
	);

	// Gesamtpreis anzeigen
	$ad_pc_jq_1_11_3("#info_content_final_price").remove();
	var pcPriceTotal = _i18n.translate("Total Price").fetch();
	if( _ad_pc_version_running == AD_PC_VERSION_XTC && _xtcPriceTotalString != '' ) {
		pcPriceTotal = _xtcPriceTotalString;
	}
	var pcPriceTotalOutString = '<p>' + pcPriceTotal + ': '  + _currencyString + ' ' + getFinalSurcharge(prices) + '</p>';
	var taxAndShippingOut = '';
	if( typeof _taxInfoString != 'undefined' && _taxInfoString != '' ) {
		taxAndShippingOut = '<p class="product-tax-shipping">' + _taxInfoString;
	}
	if( typeof _shippingInfoString != 'undefined' && _shippingInfoString != '' ) {
		if( taxAndShippingOut != '' ) {
			taxAndShippingOut += ' ';
		}
		if( typeof _xtcShippingLink != 'undefined' && _xtcShippingLink != '' ) {
			taxAndShippingOut += '<a href="' + _xtcShippingLink + '" target="_blank" rel="nofollow">' + _shippingInfoString + '</a>'
		}
		else {
			taxAndShippingOut += _shippingInfoString
		}
	}
	if( taxAndShippingOut != '' ) {
		pcPriceTotalOutString += '<p class="product-tax-shipping">' + taxAndShippingOut + '</p>';
	}
	$ad_pc_jq_1_11_3(infoDiv).append(
		'<div id="info_content_final_price" class="product_config_price product_config_price_total">' + pcPriceTotalOutString + '</div>'
	);
}

function getUserInputCollectionValues( usrInpColDiv ) {
	var uInpColVals = new Array();
	var usrInpColTypeDiv = usrInpColDiv.find('input[id^=ad_pc_uinp_col_type_]');
    var usrInpDivs = usrInpColDiv.find('div.user_input_div');
    usrInpDivs.each(function (index) {
    	var uI = $ad_pc_jq_1_11_3(this);
    	var uIValue = uI.find('.ad_pc_usr_inp_val').val();
        uInpColVals.push(uIValue);
    });
    return uInpColVals;
}

function getUserInputCollectionType( usrInpColDiv ) {
    var uInpColVals = new Array();
    var usrInpColTypeDiv = usrInpColDiv.find( 'input[id^=ad_pc_uinp_col_type_]' );
    return usrInpColTypeDiv.val();
}

function getUserInputCollectionOutput( usrInpColDiv ) {
	var usrInpOutputInfo = '';
	var usrInpColTypeDiv = usrInpColDiv.find('input[id^=ad_pc_uinp_col_type_]');
	var usrInpColType = usrInpColTypeDiv.val();
    var usrInpDivs = usrInpColDiv.find('div.user_input_div');
    usrInpDivs.each(function (index) {
        var uI = $ad_pc_jq_1_11_3(this);
        if (usrInpOutputInfo == '') {
            usrInpOutputInfo = '(';
        }
        else {
            usrInpOutputInfo += '; ';
        }
        var uITitle = uI.find('label.ad_pc_usr_inp_title').text();
        if (uITitle != 0 && uITitle != '') {
            usrInpOutputInfo += String(uITitle) + ': ';
        }
        var uIValue = uI.find('.ad_pc_usr_inp_val').val();
        usrInpOutputInfo += String(uIValue);
        var uIUnit = uI.find('.ad_pc_usr_inp_unit').text();
        if (uIUnit != 0 && uIUnit != '' && uIValue != '') {
            usrInpOutputInfo += String(uIUnit);
        }
    });
    // if collection type equals Area (5), Volume (6), Circle diameter (7) or Circle perimeter (8)
    if (String(usrInpColType) == '5' || String(usrInpColType) == '6' || String( usrInpColType ) == '7' || String( usrInpColType ) == '8') {
        var uICalcDiv = usrInpColDiv.find('div.ad_pc_calc_uinpcol');
        var uICalcTitle = String(uICalcDiv.find('label.ad_pc_calc_uinpcol_title_label').text());
        var uICalcVal = String(uICalcDiv.find('label.ad_pc_calc_label_uinpcol').text());
        var uICalcUnit = String(uICalcDiv.find('label.ad_pc_calc_uinpcol_unit_label').text());
        var uICalcUnitVal = String(uICalcDiv.find('label.ad_pc_calc_uinpcol_unit_val_label').html());
        usrInpOutputInfo += '; ' + uICalcTitle + uICalcVal + uICalcUnit + uICalcUnitVal;
    }
    if (usrInpOutputInfo != '') {
        usrInpOutputInfo += ')';
    }

    return usrInpOutputInfo;
}

var _i18n;

function initSelectyTranslations( translations ) {
	_i18n = new Jed(translations);
}

$ad_pc_jq_1_11_3(window).on('DOMContentLoaded load resize scroll', function(){
	var cBigPic = $ad_pc_jq_1_11_3("#config_big_picture");
	if( cBigPic.length > 0 ) {
		cBigPic.css({position:'relative'});
		var rect = cBigPic[0].getBoundingClientRect();
		if( rect.top <= _config_big_picture_top_min_dist ) {
			cBigPic.css({top: _config_big_picture_top_min_dist, position:'fixed'});
		}
	}
});

$ad_pc_jq_1_11_3(document).ready(function () {
	$ad_pc_jq_1_11_3(infoDiv).append(
		'<ul id="info_content_ul" class="list-group"></ul>'
	);

	// load translations
	var htmlLang = $ad_pc_jq_1_11_3('html')[0].lang;
	var translationUrl = translationBasePath + "selecty_lang_" + htmlLang + ".json";
	$ad_pc_jq_1_11_3.ajax({
		dataType: 'json',
		url: translationUrl,
		data: {},
		success: function( data, textStatus, jqXHR ) {
			initSelectyTranslations( data );
            // only when translations are loaded and base values are initialized it makes sense to start the product configurator
            _tranlationsLoaded = true;
            if ( _baseValuesInitialized ) {
                startConfigure( _productId, _configDivId );
            }
		},
		error: function( jqXHR, textStatus, errorThrown ) {
			// set the translationsUrl to the default one (english should always be available)
			translationUrl = translationBasePath + "selecty_lang_en.json";
			$ad_pc_jq_1_11_3.ajax({
				dataType: 'json',
				url: translationUrl,
				data: {},
				success: function( data, textStatus, jqXHR ) {
					initSelectyTranslations( data );
                    // only when translations are loaded and base values are initialized it makes sense to start the product configurator
					_tranlationsLoaded = true;
					if( _baseValuesInitialized ) {
                        startConfigure( _productId, _configDivId );
					}
				},
				error: function( jqXHR, textStatus, errorThrown ) {
					// todo: implement error handling if not even 'selecty_translations_en.json' was found or it couldn't be transmitted
				}
			});
		}
	});
});

function getPriceStr(price) {
	if (price != 0) {
		var returnPrice = price;
		returnPrice = parseFloat(price).toFixed(2);
		returnPrice = returnPrice.replace(".", ",")
		return returnPrice;
	} else {
		return price;
	}
}

//calculate end price
function getFinalSurcharge(prices) {
	var price = 0;
	for (var key in prices) {
		if (prices.hasOwnProperty(key)) {
			var tmp = String(prices[key]).replace(",", ".")
			price += parseFloat(tmp);
		}
	}
	if(_ad_pc_version_running == AD_PC_VERSION_XTC) {
		return getPriceStr(parseFloat(price*_discountMultiplier)+parseFloat(_xtcBasePrice));
	}
	return getPriceStr(price*_discountMultiplier);
}

//show big picture
function showBigPicture(imgPath, color, title) {
	var cBigPic = $ad_pc_jq_1_11_3("#config_big_picture");

	if( cBigPic.length > 0 ) {
		if (color == 'false') {
			cBigPic.append('<img src="' + picturePath + imgPath + '">')
			cBigPic.append('<p class="big_picture_title">' + title + '</p>')
		} else {
			cBigPic.append('<div style="background-color: #' + color + '"></div>')
			cBigPic.append('<p class="big_picture_title">' + title + '</p>')
		}
		cBigPic.show();

		cBigPic.css({position:'relative'});
		var rect = cBigPic[0].getBoundingClientRect();
		if( rect.top <= 15 ) {
			cBigPic.css({top: 15, position:'fixed'});
		}
	}
}

//hide big picture
function hideBigPicture() {
	var cBigPic = $ad_pc_jq_1_11_3("#config_big_picture");
	if( cBigPic.length > 0 ) {
		cBigPic.empty();
		cBigPic.hide();
	}
}


//append submit finish button if the configuration is done
function handleFinishedConfig() {
	configFinished = true;
	if( _ad_pc_version_running == AD_PC_VERSION_STANDALONE ) {
		$ad_pc_jq_1_11_3(contentDiv).append('<button id="final_config_button" onClick="setConfiguration();" type="button" class="btn btn-success">' + _i18n.translate("Finish Configuration").fetch() + '</button>');
	}
	else if( _ad_pc_version_running == AD_PC_VERSION_XTC ) {
		// get the 'add to cart' forms
		var cForms = getXtcAddToCartForms(true);
		// activate the 'add to cart' buttons
		var submitButtons = getXtcAddToCartButtons(cForms);
		$ad_pc_jq_1_11_3.each(submitButtons, function( index, value ) {
			value.prop('disabled', false);
            if( _adPcUserInputExisting && !checkOptionBitwise( _licOption, '0001000' ) ) {		// option:  0001000	=> user input
				value.prop('disabled', true);
			}
		});
		// loop over each configuration option
		$ad_pc_jq_1_11_3(contentDiv).children('div').each(function(){
			// loop over each value
			$ad_pc_jq_1_11_3(this).find('div[id^=option_node_radio_div_]').each(function(){
				var radioDiv = $ad_pc_jq_1_11_3(this);
				// check if this value is checked
				if( radioDiv.find('input:radio:checked').length == 1 ) {
					// append a hidden input containing the option and value info to the XTC form
					var radioDivId = radioDiv.attr('id');
					var radioDivIdValuesSep1 = radioDivId.lastIndexOf('_');
					var radioDivIdValuesSep2 = radioDivId.lastIndexOf('_', radioDivIdValuesSep1 - 1);
					var radioDivIdOptionOptionValuePart = radioDivId.substr(radioDivIdValuesSep2 + 1);
					var selInfoInputId = 'ad_pc_opt_val_chosen_' + radioDivIdOptionOptionValuePart;
					var selInfoInputName = 'ad_pc_opt_' + radioDivIdOptionOptionValuePart;
					var usrInpColDiv = radioDiv.find('div[id^=user_input_col_div_]');
					var selInfoValue = getUserInputCollectionOutput( usrInpColDiv );
					var selInfoInput = $ad_pc_jq_1_11_3(document.createElement('input'));
					selInfoInput.attr('id', selInfoInputId);
					selInfoInput.attr('name', selInfoInputName);
					selInfoInput.attr('type', 'hidden');
					selInfoInput.val(selInfoValue);
					selInfoInput.appendTo(cForms);

					var uInpColsVals = getUserInputCollectionValues( usrInpColDiv );
					for( var uInpColValsIndex = 0; uInpColValsIndex < uInpColsVals.length; uInpColValsIndex++ ) {
						var selInfoUInpInputId = 'ad_pc_uinp_' + radioDivIdOptionOptionValuePart + '_' + uInpColValsIndex;
                        var selInfoUInpInput = $ad_pc_jq_1_11_3(document.createElement('input'));
                        selInfoUInpInput.attr('id', selInfoUInpInputId);
                        selInfoUInpInput.attr('name', selInfoUInpInputId);
                        selInfoUInpInput.attr('type', 'hidden');
                        selInfoUInpInput.val( uInpColsVals[uInpColValsIndex] );
                        selInfoUInpInput.appendTo(cForms);
                        var uInpColType = getUserInputCollectionType( usrInpColDiv );
                        // if there is more then one input for an option or the option type is Circle (7 or 8) transfer the xD (2D, 3D) label-name too
                        if( (uInpColsVals.length > 1 && uInpColValsIndex == uInpColsVals.length - 1) || uInpColType == 7 || uInpColType == 8 ) {
                        	var selInfoUInpXDInputId = 'ad_pc_xd_label_uinp_' + radioDivIdOptionOptionValuePart + '_' + uInpColValsIndex;
                        	var selInfoUInpXDInputValue = '';
                        	if( uInpColType == 7 || uInpColType == 8 ) {
                                selInfoUInpXDInputValue = _i18n.translate( "Area" ).fetch();
							}
                        	else if( uInpColValsIndex == 1 ) {
                        		selInfoUInpXDInputValue = _i18n.translate("Area").fetch();
							}
							else if( uInpColValsIndex == 2 ) {
                        		selInfoUInpXDInputValue = _i18n.translate("Volume").fetch();
							}
                        	var selInfoUInpxDInput = $ad_pc_jq_1_11_3(document.createElement('input'));
							selInfoUInpxDInput.attr('id', selInfoUInpXDInputId);
							selInfoUInpxDInput.attr('name', selInfoUInpXDInputId);
							selInfoUInpxDInput.attr('type', 'hidden');
							selInfoUInpxDInput.val( selInfoUInpXDInputValue );
							selInfoUInpxDInput.appendTo(cForms);
						}
					}
				}
			});
		});
	}
	$ad_pc_jq_1_11_3(document).trigger('ad_pc_config_finished');
}

//set session for the configuration
function setConfiguration() {
	if( _ad_pc_version_running == AD_PC_VERSION_STANDALONE ) {
		setSession();
	}
}

// ajax call for the config
function startConfigure(productId, configDivId) {
    _configStarted = true;
	_productId = productId;

	if( _ad_pc_version_running == AD_PC_VERSION_XTC ) {
		var submitButtons = getXtcAddToCartButtons();
		$ad_pc_jq_1_11_3.each(submitButtons, function( index, value ) {
			value.prop('disabled', true);
		});

        if( checkOptionBitwise( _licOption, '0000010' ) ) {		// option:  0000010	=> text exclusive
			$ad_pc_jq_1_11_3('#'+configDivId).addClass('text_exclusive_input');
		}
	}

	$ad_pc_jq_1_11_3.ajax({
		dataType: 'json',
		method: "POST",
		url: configurator_path,
		data: {
			article_id: productId
		}
	}).done(function (response) {
        showInfoContentDiv();
		checkResponse(response, {configDivId: configDivId});
	});
}

// Call to start the configuration if dependencies are loaded later.
// The input parameters for startConfigure have to be set at calling time.
// This function is called from the XTC template.
function startConfigureRaw() {
	if( !_configStarted ) {
        startConfigure( _productId, _configDivId );
	}
}

function processOptionValueSelection(node_id, value_id, userInputValues, priceFromCsv, lvl, radioName, rType, id) {
	// if user input is area check if a price change from CSV-file is defined
	if( Array.isArray(userInputValues) && userInputValues.length == 2 && priceFromCsv ) {
		_csvPriceChgC.setInfoContent = true;		// remember to set the temporary values when handling the info content creation
		_csvPriceChgC.useCsvPriceOnly = true;		// remember to only use the CSV-value for price calculation (ignore the user inputs as multipliers)
		sendAjaxRequest(node_id, value_id, userInputValues, lvl, radioName, rType, id, true);
	}
	else {
		processStdSendAjaxRequest(node_id, value_id, userInputValues, lvl, radioName, rType, id);
	}
}

function processStdSendAjaxRequest(node_id, value_id, userInputValues, lvl, radioName, rType, id) {
	if (checkConfigLvl(lvl, radioName, rType, id) === true) {
		if (Object.prototype.toString.call(userInputValues) === '[object Array]' && userInputValues.length > 0) {
			// todo: user input could be evaluated here too instead of always when the input changes. This would result
			// in better performance but no real time checking would be done anymore. It does not seem to be necessary
			// to check it two times. So there is no implementation here as it is done when users enters something.
		}
        var optionNodeRadioDiv = $ad_pc_jq_1_11_3("#option_node_radio_div_" + node_id + "_" + value_id);
		sendAjaxRequest(node_id, value_id, userInputValues, lvl, radioName, rType, id, false);
	}
}

// ajax call for the initialisation and loading
function sendAjaxRequest(node_id, value_id, userInputValues, lvl, radioName, rType, id, checkPrcChgOnly) {
    // create the data to send for this config step
    var configStepData = {
			option_node_id: node_id,
			option_value_id: value_id,
			c_lvl: lvl,
			user_input: JSON.stringify( userInputValues ),
			prc_chg_only: checkPrcChgOnly
		};

	$ad_pc_jq_1_11_3.ajax({
		method: "POST",
		url: configurator_path,
		data: configStepData
	}).done(function (response) {
		if( response.price_chg_only ) {
			updateUserInputPriceFromCsv(node_id, value_id, userInputValues, lvl, radioName, rType, id, handleTax(response.price_chg))
		}
		else {
			showInfoContentDiv();
			var prevOptInfos = {
				node_id: node_id,
				value_id: value_id,
				userInputValues: userInputValues,
				lvl: lvl,
				radioName: radioName,
				rType: rType,
				id: id
			};
			checkResponse(response, prevOptInfos);
		}
	});
}

function updateUserInputPriceFromCsv(node_id, value_id, userInputValues, lvl, radioName, rType, id, prcChg) {
    _csvPriceChgC.prc_chg = prcChg;
    _csvPriceChgC.node_id = node_id;
    _csvPriceChgC.value_id = value_id;

	// handle the price change from csv file
	var currentCsvPriceCalcDiv = $ad_pc_jq_1_11_3('#prc_csv_calc_'+node_id+'_'+value_id);
	if( currentCsvPriceCalcDiv.length > 0 ) {
		currentCsvPriceCalcDiv.remove();
	}
	var optionNodeRadioDiv = $ad_pc_jq_1_11_3("#option_node_radio_div_"+node_id+"_"+value_id);
	var userInputColDiv = optionNodeRadioDiv.find("[id^='user_input_col_div_']");
	var calcUinpcol = userInputColDiv.find("[id^='ad_pc_calc_uinpcol_']");
	var newPrcCsvDiv = $ad_pc_jq_1_11_3(
		'<div id="prc_csv_calc_'+node_id+'_'+value_id+'" class="ad_pc_calc_csv_prc">' +
			'<label class="ad_pc_calc_csv_prc_title_label">'+_i18n.translate("Price").fetch()+':&nbsp;</label>' +
			'<label class="ad_pc_calc_csv_prc_unit_label">'+_currencyString+'&nbsp;</label>' +
			'<label class="ad_pc_calc_csv_prc_price_label">'+getPriceStr(prcChg)+'</label>' +
		'</div>' );
	newPrcCsvDiv.insertAfter(calcUinpcol);

	processStdSendAjaxRequest(node_id, value_id, userInputValues, lvl, radioName, rType, id);
}

// ajax call for the session
function setSession() {
	$ad_pc_jq_1_11_3.ajax({
		method: "POST",
		url: sessionHandlerPath,
		data: {
			id: _productId,
			config: configuration
		}
	}).done(function (response) {
		$ad_pc_jq_1_11_3('#ad_pc_wrapper_config_content').trigger( 'ad_pc_config_finished', [
            _productId,
            configuration
		] );
	});
}

function setDiscountMultiplier( discountMultiplier ) {
	_discountMultiplier = discountMultiplier;
}

function setXtcBaseValues( basePrice, currency, priceTotalString, pricesIncludeTax, taxValue, taxInfoString, shippingInfoString, shippingLink, licOption ) {
	_xtcBasePrice = basePrice;
	_currencyString = currency;
	_xtcPriceTotalString = priceTotalString;
	_pricesIncludeTax = parseInt(pricesIncludeTax);
	_taxValue = parseFloat(taxValue);
	_licOption = licOption;

	if( taxInfoString ) { _taxInfoString = taxInfoString; }
	if( shippingInfoString ) { _shippingInfoString = shippingInfoString; }
	if( shippingLink ) { _xtcShippingLink = shippingLink; }
}

function setStandaloneBaseValues( licOption ) {
    _licOption = licOption;
}

function showInfoContentDiv() {
    // show info content div if it is not displayed yet
    var configContentInfoDiv = $ad_pc_jq_1_11_3('#ad_pc_config_content_info');
    if (configContentInfoDiv.css('display') == 'none') {
        configContentInfoDiv.fadeIn(500);
    }
}

function getXtcAddToCartForms( cleanBefore ) {
	cleanBefore = (typeof cleanBefore !== 'undefined' && cleanBefore !== null) ? cleanBefore : false;
	var cForms = new Array();
	if( _ad_pc_version_running == AD_PC_VERSION_XTC ) {
		// get all inputs with name 'product'
		var productInput = $ad_pc_jq_1_11_3("input[name='product']");
		// loop over them
		productInput.each(function (index) {
			// retrieve its parent form
			var cFormEl = $ad_pc_jq_1_11_3(this).parents("form[name^='product']");
			// check if the element is below the div with class 'pcontent' which indicates it is in the description or below it (e.g. in product slider for x-selling). We dont wan't to care about this submit buttons.
			var pContentIsAnchestor = $ad_pc_jq_1_11_3(this).closest('.pcontent');
			if( pContentIsAnchestor && pContentIsAnchestor.length == 0 ) {
				if (cleanBefore === true) {
					var selInfoInputs = cFormEl.find('input[id^=ad_pc_opt_val_chosen_]');
					selInfoInputs.each(function(){
						$ad_pc_jq_1_11_3(this).remove();
					});
					var selInfoUInpInputs = cFormEl.find('input[id^=ad_pc_opt_val_uinp_]');
					selInfoUInpInputs.each(function(){
						$ad_pc_jq_1_11_3(this).remove();
					});
				}
				cForms.push( cFormEl );
			}
		});
	}
	// check if the parent form is set
	if (cForms && cForms.length >= 1) {
		return cForms;
	}
	return false;
}

function getXtcAddToCartButtons(cForms ) {
	var addToCartButtons = new Array();
	if (cForms === undefined) {
		cForms = getXtcAddToCartForms(false);
	}
	if( cForms ) {
		// get the forms submit button (this is the XTC 'Add to cart' button)
		$ad_pc_jq_1_11_3.each(cForms, function( index, value ) {
			// check if the element is below the div with class 'pcontent' which indicates it is in the description or below it (e.g. in product slider for x-selling). We dont wan't to care about this submit buttons.
			var pContentIsAnchestor = value.closest('.pcontent');
			if( pContentIsAnchestor && pContentIsAnchestor.length == 0 ) {
                addToCartButtons.push(value.find(":submit"));
            }
		});
	}
	return addToCartButtons;
}

function escapeHtml(text) {
	var map = {
		'&': '&amp;',
		'<': '&lt;',
		'>': '&gt;',
		'"': '&quot;',
		"'": '&#039;'
	};

	return text.replace(/[&<>"']/g, function(m) { return map[m]; });
}
